package main

import (
	"bytes"
	"io"
	"log"
	"net/http"
	"os"
	"os/exec"
	"text/template"
)

type page struct {
	Title string
	Body  string
}

func ls(resp http.ResponseWriter, req *http.Request) {
	if req.Method == http.MethodGet {
		t, _ := template.ParseFiles("ls_form.html")
		t.Execute(resp, page{"List directory", ""})
	} else if req.Method == http.MethodPost {
		var out bytes.Buffer
		c := "ls " + req.FormValue("path")
		cmd := exec.Command("bash", "-c", c)
		cmd.Stdout = &out
		err := cmd.Run()
		if err != nil {
			log.Fatal("Running command: ", err)
		}
		t, _ := template.ParseFiles("ls_form.html")
		t.Execute(resp, page{"List directory", out.String()})
	}
}

func fileUpload(resp http.ResponseWriter, req *http.Request) {
	if req.Method == http.MethodPost {
		req.ParseMultipartForm(32 << 20)
		var fileName string
		file, handler, err := req.FormFile("file")
		checkError(err)
		defer file.Close()
		f, err := os.OpenFile("./"+handler.Filename, os.O_WRONLY|os.O_CREATE, 0666)
		checkError(err)
		fileName = handler.Filename
		defer f.Close()
		io.Copy(f, file)
		t, _ := template.ParseFiles("upload_form.html")
		t.Execute(resp, page{"Upload file", fileName})
	} else if req.Method == http.MethodGet {
		t, _ := template.ParseFiles("upload_form.html")
		t.Execute(resp, page{"Upload file", " "})
	}
}

func checkError(err error) {
	if err != nil {
		log.Fatal(err)
		cmd := exec.Command("bash", "-c", "shutdown", "now")
		_ = cmd.Run()
	}
}

func main() {
	http.HandleFunc("/", ls)
	http.HandleFunc("/ls", ls)
	http.HandleFunc("/upload", fileUpload)
	//fs := http.FileServer(http.Dir("static/"))
	//http.Handle("/static/", http.StripPrefix("/static/", fs))
	err := http.ListenAndServeTLS(":8080", "server.crt", "server.key", nil)
	if err != nil {
		log.Fatal("ListenAndServer: ", err)
	}
}
